//
// Topsider - Raumschiff
//
// (c)'97 AlexNofftz @aol.com
//

#include "colors.inc"
#include "glass.inc"
#include "metals.inc"

camera {
  location <-2, 2.0, -3>
  look_at 0
}

light_source { <-100, 100, -100> rgb <1, 1, 1> }
light_source { <-40, 60, -100> rgb <.8, .8, .8> }

#declare Triebwerksmodul =
  cylinder { -.05 * x, .05 * x, 0.04 }

#declare Triebwerk =
  union {
    object { Triebwerksmodul translate -0.05 * z }
    object { Triebwerksmodul translate  0.05 * z }
    object { Triebwerksmodul translate -0.05 * y }
    object { Triebwerksmodul translate  0.05 * y }
  }

#declare Beobachtungskuppel =
  sphere {
    0, .05
    scale <2, 1, 1>
    texture { T_Glass3 }
    hollow
  }

#declare Rumpfring =        // Verstrkungsring
  torus {
    .1, .02
    rotate 90 * z
  }

#declare Flosse =
/*  polygon {
    5,
    <0, 0>, <0.02, 0>, <0.03, 0.15>, <0.01, 0.15>, <0, 0>
    translate 0.1 * y
  }*/
  box { <0, 0, -.002>, <.15, 1/3, .002> rotate -10 * z }

#declare Stabilisatoren =
  union {
    object { Flosse }
    object { Flosse rotate  45 * x }
    object { Flosse rotate -45 * x }
  }

#declare Triebwerksgondel =
  merge {
    object { Flosse scale 20/9 }
    cylinder { <0, 2/3>, <.6, 2/3>, .05 }
    cone { <0, 2/3>, .05, <-.2, 2/3>, 0 }
  }

#declare Triebwerksgondeln =
  union {
    object { Triebwerksgondel }
    object { Triebwerksgondel rotate  90 * x }
    object { Triebwerksgondel rotate 180 * x }
    object { Triebwerksgondel rotate 270 * x }
  }

#declare Rumpf =
  merge {
    cone { -1.5 * x, .1, -2 * x, 0 }           // Vordere Spitze
    sphere { 0, 1/3 }                          // Kommandokugel
    object { Rumpfring translate -1/3 * x }    // Befestigungsringe d. K-Kugel
    object { Rumpfring translate  1/3 * x }
    cylinder { -1.5 * x, 1.5 * x, .1 }
    object { Stabilisatoren translate -.8 * x scale 0.8 } 
    object { Stabilisatoren translate 2/3 * x }
    object { Triebwerksgondeln translate 1.2 * x }
    texture { T_Chrome_3C }
//    pigment { rgb <.6, .6, .6> }
  }

//#declare Topsider =
union {
  object { Rumpf }
  object { Beobachtungskuppel translate <-1.1, .1, 0> }
  object { Triebwerk translate 1.5 * x }
}


// Extras
// ------

// Lmpchen um die Kommandokugel

#declare Lampe = sphere { 0, 1/50 pigment { rgb <1, 1, 1> } }

#declare a = 0
#while (a != 10)
  light_source {
    <0, cos (a * pi / 5) / 3, sin (a * pi / 5) / 3>
    White
    looks_like { Lampe }
  }
  #declare a = a + 1
#end

// Triebwerkfeuer

#declare Feuer = cone {
  0, .1, 1.5 * x, 1/3
  pigment { rgbt <1, 1, 1, 1> }
  halo {
    emitting
    cylindrical_mapping
    turbulence 0.2
    linear
    color_map {
      [0.0 rgbt <0.0, 0.0, 0.0, 1.0>]
      [0.1 rgbt <0.4, 0.0, 0.0, 0.6>]
      [0.5 rgbt <0.8, 0.1, 0.1, 0.3>]
      [0.8 rgbt <1.0, 0.6, 0.6, 0.0>]
      [1.0 rgbt <1.0, 0.6, 0.6, 0.0>]
    }
    samples 10
    scale 2/3
  }
  hollow
}

object { Feuer translate <1.5, 0, 0> }
object { Feuer scale .5 translate <1.8, 2/3, 0> }
object { Feuer scale .5 translate <1.8, 0, 2/3> }
object { Feuer scale .5 translate <1.8, -2/3, 0> }
object { Feuer scale .5 translate <1.8, 0, -2/3> }
